searchData={"items":[{"type":"module","title":"PhoenixNotif","doc":"A drop-in replacement for notification system in Phoenix.","ref":"PhoenixNotif.html"},{"type":"function","title":"PhoenixNotif.connection_group/1","doc":"","ref":"PhoenixNotif.html#connection_group/1"},{"type":"function","title":"PhoenixNotif.notification_group/1","doc":"Renders a notification group for DeadView and LiveView.\n\n  * For DeadView, it only renders flashes.\n  * For LiveView, it renders flashes and toasts.","ref":"PhoenixNotif.html#notification_group/1"},{"type":"function","title":"Attributes - PhoenixNotif.notification_group/1","doc":"* `id` (`:string`) - the DOM id of notification group. Defaults to `\"notification-group\"`.\n* `position` (`:atom`) - the location for showing notifications. Defaults to `:bottom_right`.\n* `flash` (`:map`) (required) - the map of flash messages.\n* `connected` (`:boolean`) - Defaults to `false`.","ref":"PhoenixNotif.html#notification_group/1-attributes"},{"type":"function","title":"PhoenixNotif.put_toast/4","doc":"","ref":"PhoenixNotif.html#put_toast/4"},{"type":"function","title":"PhoenixNotif.send_toast/3","doc":"","ref":"PhoenixNotif.html#send_toast/3"},{"type":"module","title":"PhoenixNotif.Base","doc":"Provides base components for deriving various types of notifications.","ref":"PhoenixNotif.Base.html"},{"type":"function","title":"PhoenixNotif.Base.notification/1","doc":"Base notification component.\n\nBased on the look and feel of [Sonner](https://sonner.emilkowal.ski/).","ref":"PhoenixNotif.Base.html#notification/1"},{"type":"function","title":"Attributes - PhoenixNotif.Base.notification/1","doc":"* `id` (`:string`) (required) - the DOM id of notification.\n* `group_id` (`:string`) (required) - the DOM id of notification group.\n* `type` (`:atom`) (required) - the type of notification.Must be one of `:flash`, `:\"lv-flash\"`, or `:\"lv-toast\"`.\n* `kind` (`:atom`) (required) - the kind of notification message.Must be one of `:info`, `:success`, `:warning`, or `:error`.\n* `duration` (`:integer`) - the time in milliseconds before the message is automatically dismissed. Defaults to `nil`.\n* `icon` (`:any`) - Defaults to `nil`.\n* `title` (`:string`) - Defaults to `nil`.\n* `message` (`:string`) - Defaults to `nil`.\n* `action` (`:any`) - Defaults to `nil`.\n* `component` (`:any`) - Defaults to `nil`.\n* `class_fn` (`:any`) - function to override the look of the notification. Defaults to `&PhoenixNotif.Base.notification_class_fn/1`.\n* Global attributes are accepted. the arbitrary attributes to add to the notification container.","ref":"PhoenixNotif.Base.html#notification/1-attributes"},{"type":"function","title":"Slots - PhoenixNotif.Base.notification/1","doc":"* `inner_block`","ref":"PhoenixNotif.Base.html#notification/1-slots"},{"type":"type","title":"PhoenixNotif.Base.kind/0","doc":"","ref":"PhoenixNotif.Base.html#t:kind/0"},{"type":"module","title":"PhoenixNotif.Flash","doc":"The flash system for DeadView and LiveView.","ref":"PhoenixNotif.Flash.html"},{"type":"function","title":"PhoenixNotif.Flash.flashes/1","doc":"Flashes are derived from `PhoenixNotif.Base`.\n\nThey won't disappear util you dismiss them.","ref":"PhoenixNotif.Flash.html#flashes/1"},{"type":"function","title":"Attributes - PhoenixNotif.Flash.flashes/1","doc":"* `group_id` (`:string`) (required)\n* `f` (`:map`) (required)\n* `live` (`:boolean`) - Defaults to `false`.","ref":"PhoenixNotif.Flash.html#flashes/1-attributes"},{"type":"module","title":"PhoenixNotif.LiveComponent","doc":"The notification system for LiveView.","ref":"PhoenixNotif.LiveComponent.html"},{"type":"function","title":"PhoenixNotif.LiveComponent.put_toast/4","doc":"Helper function around `send_toast/3` that is useful in pipelines.\n\nUnlike `send_toast/3`, this function does not expose the UUID of the\nnew toast, so if you need to update the toast after showing it, you\nshould use `send_toast/3` directly.","ref":"PhoenixNotif.LiveComponent.html#put_toast/4"},{"type":"function","title":"Examples - PhoenixNotif.LiveComponent.put_toast/4","doc":"iex> put_toast(socket, :info, \"Thank you for logging in!\")\n    %LiveView.Socket{...}","ref":"PhoenixNotif.LiveComponent.html#put_toast/4-examples"},{"type":"function","title":"PhoenixNotif.LiveComponent.send_toast/3","doc":"Send a new toast message to the PhoenixNotif component.\n\nReturns the UUID of the new toast message. This UUID can be passed back\nto another call to `send_toast/3` to update the properties of an existing toast.","ref":"PhoenixNotif.LiveComponent.html#send_toast/3"},{"type":"function","title":"Examples - PhoenixNotif.LiveComponent.send_toast/3","doc":"iex> send_toast(:info, \"Thank you for logging in!\", title: \"Welcome\")\n    \"00c90156-56d1-4bca-a9e2-6353d49c974a\"","ref":"PhoenixNotif.LiveComponent.html#send_toast/3-examples"},{"type":"type","title":"PhoenixNotif.LiveComponent.component_fn/0","doc":"`Phoenix.Component` that renders a part of the toast message.","ref":"PhoenixNotif.LiveComponent.html#t:component_fn/0"},{"type":"type","title":"PhoenixNotif.LiveComponent.option/0","doc":"Set of public options to augment the default toast behavior.","ref":"PhoenixNotif.LiveComponent.html#t:option/0"},{"type":"module","title":"PhoenixNotif.System","doc":"The notification system for system information, such as connection status.","ref":"PhoenixNotif.System.html"},{"type":"function","title":"PhoenixNotif.System.connection_group/1","doc":"Renders a connection group for showing connection status.","ref":"PhoenixNotif.System.html#connection_group/1"},{"type":"function","title":"Attributes - PhoenixNotif.System.connection_group/1","doc":"* `id` (`:string`) - the DOM id of connection group. Defaults to `\"connection-group\"`.\n* `position` (`:atom`) - the position for showing UI. Defaults to `:bottom`.\n* `client_error_message` (`:string`) - Defaults to `\"Network error, attempting to reconnect...\"`.\n* `server_error_message` (`:string`) - Defaults to `\"Service error, attempting to recover...\"`.","ref":"PhoenixNotif.System.html#connection_group/1-attributes"},{"type":"extras","title":"PhoenixNotif","doc":"# PhoenixNotif\n\n[![Hex.pm](https://img.shields.io/hexpm/v/phoenix_notif.svg)](https://hex.pm/packages/phoenix_notif)\n\nA drop-in replacement for notification system in Phoenix.","ref":"readme.html"},{"type":"extras","title":"Installation - PhoenixNotif","doc":"","ref":"readme.html#installation"},{"type":"extras","title":"1. add Hex package - PhoenixNotif","doc":"Add `:phoenix_notif` to the list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:phoenix_notif, \"~>  \"}\n  ]\nend\n```","ref":"readme.html#1-add-hex-package"},{"type":"extras","title":"2. add NPM package - PhoenixNotif","doc":"Import the frontend package shipped with this above Hex package from `../deps/phoenix_notif`.","ref":"readme.html#2-add-npm-package"},{"type":"extras","title":"3. create and use the hook - PhoenixNotif","doc":"```javascript\nimport createPhoenixNotifHook from \"phoenix_notif\"\n\nconst liveSocket = new LiveSocket(\"/live\", Socket, {\n  hooks: {\n    PhoenixNotif: createPhoenixNotifHook(),\n  },\n})\n```","ref":"readme.html#3-create-and-use-the-hook"},{"type":"extras","title":"4. help Tailwind looking for class names - PhoenixNotif","doc":"```javascript\n// Edit tailwind.config.js\n\nmodule.exports = {\n  content: [\n    // ...\n    \"../deps/phoenix_notif/lib/**/*.*ex\",\n    // ...\n  ],\n}\n```","ref":"readme.html#4-help-tailwind-looking-for-class-names"},{"type":"extras","title":"5. use components provided by this package - PhoenixNotif","doc":"Finally, replace your `<.flash_group />` component with the new components.\n\nIt's most likely in the `app.html.heex`:\n\n```heex\n<!-- Remove this! -->\n<.flash_group flash={@flash} />\n\n<!-- And replace it with this: -->\n \n \n\n<%= @inner_content %>\n```","ref":"readme.html#5-use-components-provided-by-this-package"},{"type":"extras","title":"Usage - PhoenixNotif","doc":"`PhoenixNotif` provides two types of notifications.\n\n- Flash\n- Toast - allows multiple notifications to show for each kind of toast.","ref":"readme.html#usage"},{"type":"extras","title":"Using Flash - PhoenixNotif","doc":"> It's supported by DeadView and LiveView.\n\nFlash is provided by Phoenix flash system, which only allows one notification to show for each kind of flash.\n\nUse `put_flash/3`.\n\n```elixir\npush_flash(conn, :info, \"Upload successful.\")\npush_flash(socket, :info, \"Upload successful.\")\n```","ref":"readme.html#using-flash"},{"type":"extras","title":"Using Toast - PhoenixNotif","doc":"> It's supported by LiveView only.\n\nUse `put_toast/4`:\n\n```elixir\ndefmodule DemoWeb.HomeLive do\n  def handle_event(\"submit\", _payload, socket) do\n    socket = socket\n    |> put_toast(:info, \"Upload successful.\", [title: \"Status\"])\n\n    {:noreply, socket}\n  end\nend\n```\n\nUse `send_toast/3`:\n\n```elixir\ndefmodule DemoWeb.HomeLive do\n  def handle_event(\"submit\", _payload, socket) do\n    PhoenixNotif.send_toast(:info, \"Upload successful.\", [ title: \"Status\" ])\n\n    {:noreply, socket}\n  end\nend\n```","ref":"readme.html#using-toast"},{"type":"extras","title":"License - PhoenixNotif","doc":"MIT","ref":"readme.html#license"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}